%global dlrn_nvr neutron-lib-2.10.2-1.20230510084011.6bbae46
%global dlrn 1
%define upstream_version 2.10.2
%{!?sources_gpg: %{!?dlrn:%global sources_gpg 1} }
%global sources_gpg_sign 0x01527a34f0d0080f8a5db8d6eb6c5df21b4b6363
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0

%global library neutron-lib
%global module neutron_lib

%global common_desc OpenStack Neutron library shared by all Neutron sub-projects.

Name:       python-%{library}
Version: 2.10.2
Release: 1.20230510084012%{?dist}
Summary:    OpenStack Neutron library
License:    ASL 2.0
URL:        http://launchpad.net/neutron/

Source0: neutron-lib-2.10.2-1.20230510084011.6bbae46.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=6bbae46890f458cbb0d7cb5dd87e80f07a305b53
Patch0001: 0001-Modify-port.mac_address-API-definition.patch
Patch0002: 0002-Disable-oslo.messaging-metrics.patch
Patch0003: 0003-Skip-bandit-B324-tests.patch
Patch0004: 0004-Fix-some-api-ref-typos.patch
Patch0005: 0005-Add-DSCP-mark-44.patch
Patch0006: 0006-Added-qos-plugin-to-EXT_PARENT_RESOURCE_MAPPING.patch
Patch0007: 0007-Add-API-extension-security-groups-shared-filtering.patch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
Source101:        https://tarballs.openstack.org/%{library}/%{library}-%{upstream_version}.tar.gz.asc
Source102:        https://releases.openstack.org/_static/%{sources_gpg_sign}.txt
%endif

BuildArch:  noarch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
BuildRequires:  /usr/bin/gpgv2
%endif

BuildRequires:  python3-devel
BuildRequires:  python3-pbr
BuildRequires:  python3-setuptools
BuildRequires:  git-core
BuildRequires:  openstack-macros

%description
%{common_desc}

%package -n  python3-%{library}
Summary:    OpenStack Neutron library
%{?python_provide:%python_provide python3-%{library}}
# Required for tests
BuildRequires: python3-keystoneauth1
BuildRequires: python3-oslotest
BuildRequires: python3-stestr
BuildRequires: python3-testtools
BuildRequires: python3-osprofiler
BuildRequires: python3-pecan
BuildRequires: python3-six
BuildRequires: python3-testscenarios
BuildRequires: python3-testresources
BuildRequires: python3-os-ken
BuildRequires: python3-os-traits
BuildRequires: python3-oslo-context
BuildRequires: python3-oslo-concurrency
BuildRequires: python3-oslo-db
BuildRequires: python3-oslo-i18n
BuildRequires: python3-oslo-log
BuildRequires: python3-oslo-utils
BuildRequires: python3-oslo-versionedobjects
BuildRequires: python3-oslo-policy
BuildRequires: python3-oslo-service
BuildRequires: python3-fixtures
BuildRequires: python3-netaddr

BuildRequires: python3-setproctitle

Requires:   python3-pbr
Requires:   python3-keystoneauth1 >= 3.4.0
Requires:   python3-netaddr >= 0.7.18
Requires:   python3-os-ken >= 0.3.0
Requires:   python3-os-traits >= 0.9.0
Requires:   python3-oslo-concurrency >= 3.26.0
Requires:   python3-oslo-config >= 2:5.2.0
Requires:   python3-oslo-context >= 2.19.2
Requires:   python3-oslo-db >= 4.37.0
Requires:   python3-oslo-i18n >= 3.15.3
Requires:   python3-oslo-log >= 3.36.0
Requires:   python3-oslo-messaging >= 5.29.0
Requires:   python3-oslo-policy >= 1.30.0
Requires:   python3-oslo-serialization >= 2.18.0
Requires:   python3-oslo-service >= 1.24.0
Requires:   python3-oslo-utils >= 3.33.0
Requires:   python3-oslo-versionedobjects >= 1.31.2
Requires:   python3-sqlalchemy >= 1.2.0
Requires:   python3-sqlalchemy < 1.4.0
Requires:   python3-stevedore
Requires:   python3-osprofiler >= 1.4.0
Requires:   python3-pecan >= 1.0.0
Requires:   python3-webob >= 1.7.1

Requires:   python3-setproctitle

%description -n python3-%{library}
%{common_desc}


%package -n python3-%{library}-tests
Summary:    OpenStack Neutron library tests
%{?python_provide:%python_provide python3-%{library}-tests}
Requires:   python3-%{library} = %{version}-%{release}

%description -n python3-%{library}-tests
%{common_desc}

This package contains the Neutron library test files.

%if 0%{?with_doc}
%package doc
Summary:    OpenStack Neutron library documentation

BuildRequires: python3-sphinx
BuildRequires: python3-openstackdocstheme

%description doc
%{common_desc}

This package contains the documentation.
%endif

%prep
# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
%{gpgverify}  --keyring=%{SOURCE102} --signature=%{SOURCE101} --data=%{SOURCE0}
%endif
%autosetup -n %{library}-%{upstream_version} -S git

# Let's handle dependencies ourseleves
%py_req_cleanup

%build
%{py3_build}

%if 0%{?with_doc}
# generate html docs
export PYTHONPATH=.
sphinx-build-3 -b html doc/source doc/build/html
# remove the sphinx-build-3 leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%{py3_install}

%check
rm -f ./neutron_lib/tests/unit/hacking/test_checks.py
export OS_TEST_PATH='./neutron_lib/tests/unit'
export PATH=$PATH:$RPM_BUILD_ROOT/usr/bin
export PYTHONPATH=$PWD
PYTHON=python3 stestr-3 --test-path $OS_TEST_PATH run

%files -n python3-%{library}
%license LICENSE
%{python3_sitelib}/%{module}
%{python3_sitelib}/%{module}-*.egg-info
%exclude %{python3_sitelib}/%{module}/tests

%files -n python3-%{library}-tests
%license LICENSE
%{python3_sitelib}/%{module}/tests

%if 0%{?with_doc}
%files doc
%license LICENSE
%doc doc/build/html README.rst
%endif

%changelog
* Tue Jun 20 2023 Lon Hohberger <lhh@redhat.com> 2.10.2-1.20230510084012
- Add API extension "security-groups-shared-filtering" (rhbz#2210030)

* Wed May 10 2023 OSP Prod Chain <dev-null@redhat.com> 2.10.2-1.20230510084011.6bbae46
- Added "qos" plugin to "EXT_PARENT_RESOURCE_MAPPING" (rhbz#2196291)

* Fri Oct 21 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-1.20221021165421.6bbae46
- Update patches

* Thu Sep 22 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-1.20220922134113.6bbae46
- Add DSCP mark 44 (rhbz#2128822)

* Wed Jul 27 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-1.20220728010209.6bbae46
- Update patches

* Mon Jul 18 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-1.20220718125332.6bbae46
- Update patches

* Thu Jul 14 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-1.20220714104342.6bbae46
- Fix some api-ref typos (rhbz#2000618)
- Skip bandit B324 tests (rhbz#2105359)

* Tue Jul 12 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-0.20220712162558.6bbae46
- Update patches

* Tue Feb 08 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-0.20220208102730.6bbae46
- Disable "oslo.messaging" metrics (rhbz#2048796)

* Thu Feb 03 2022 OSP Prod Chain <dev-null@redhat.com> 2.10.2-0.20220203162226.6bbae46
- Update patches
- Enforce policy for qos_policy_id attribute
- [Stable Wallaby Only] CI Jobs fixes
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby

* Wed Jun 23 2021 OSP Prod Chain <dev-null@redhat.com> 2.10.1-0.20210623082016.d73449d
- Modify "port.mac_address" API definition (rhbz#1974655)

* Thu May 27 2021 OSP Prod Chain <dev-null@redhat.com> 2.10.1-0.20210528002637.d73449d
- Update patches

* Fri Mar 26 2021 OSP Prod Chain <dev-null@redhat.com> 2.10.1-1
- Update patches

* Wed Mar 24 2021 OSP Prod Chain <dev-null@redhat.com> 2.10.0-1
- Update patches
- Update model_query_scope_is_project to work properly with new policies
- Make neutron-lib aware about system scope tokens
- Populate full VLAN range in "parse_network_vlan_ranges"
- Add PLACEMENT_REPORT plugin constant

* Fri Feb 19 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add shared attribute to address groups for RBAC
- Fix address groups API definition
- Add qos rule validation for network
- Introduce rbac-address-group api extension
- Remove "tag" and "tag-ext" extensions from "tags" documentation
- Add description for the "tag-ports-during-bulk-creation" extension
- Add new VNIC types for Cyborg provisioned ports

* Fri Jan 15 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add desc support to the BaseWorker initialization
- Update TOX_CONSTRAINTS_FILE for master
- [goal] Deprecate the JSON formatted policy file
- New api-def: port-device-profile
- Update lower-constraints for new pip resolver
- Remove "autonested_transaction" method
- Add const for ports bulk resource extenders
- Add `access_as_readonly` sharing action

* Thu Dec 17 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Dec 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Dec 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update TOX_CONSTRAINTS_FILE for stable/victoria
- Update .gitreview for stable/victoria
- add vnic type vdpa
- Add address groups to callbacks resources
- Add address group in use exception
- Start running pylint for pep8 tests
- Update TOX_CONSTRAINTS_FILE for stable/victoria
- Update .gitreview for stable/victoria
- Add BRODCAST_MAC constant with "FF:FF:FF:FF:FF:FF" value
- Add Python3 wallaby unit tests
- Update master for stable/victoria

* Tue Dec 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Nov 25 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Oct 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Oct 07 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- remove rc from allocation dict if value is 0
- Update TOX_CONSTRAINTS_FILE for stable/victoria
- Update .gitreview for stable/victoria
- Fix lower-constraints job for focal

* Thu Sep 10 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- New exception QosPlacementAllocationConflict
- Add placement client methods for allocations
- Use importlib to take place of imp module
- Add remote_address_group_id field in SG rules
- Add source_ip_prefix and destination_ip_prefix to metering label rules
- Deprecate 'remote_ip_prefix' parameter in metering label rules
- Log time of the apply_func only if it took more than 0.1 second
- Fix: port attribute name propagate_uplink_status
- Add neutron-tempest-plugin-api job to be gating in neutron-lib
- [api-ref] Added warning about overwriting router's default routes

* Mon Aug 10 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Change "propagate_uplink_status" default value to True
- New api-def: port-numa-affinity-policy
- Add address group exceptions
- Add DEVICE_OWNER_ROUTED constant
- API definition for SG group rules address groups.
- Add API definition for SG rule's normalized_cidr field
- Add "supported_extensions" method to MechanismDriver
- Neutron agent-list API added with sort_key keyword
- Change policy on neutron-lib migration
- Metadata addresses
- [FWaaS] Add note about deprecation of the neutron-fwaas project

* Wed Jun 24 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Add new shim API extension for dns domain with keywords
- [OVN] Add distributed device_owner
- Add agent process name constants alongside type
- [Docs] Note about port's binding_profile update
- Correctly define DHCP port numbers for IPv4
- Check time to apply resource helper functions
- Migrate timecost decorator to neutron-lib
- Remove translation sections from setup.cfg
- Rehome abstract class LinuxInterfaceDriver definition
- Remove redefined constant
- Switch to newer openstackdocstheme and reno versions
- Fix policy enforcement for network mtu
- Add aggressive negotiation mode for ikepolicy
- Update to victoria jobs template
- Fix errors found by new pycodestyle
- Update to hacking 3.0
- Update master for stable/ussuri

* Wed Apr 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Apr 08 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Switch to hacking 2.0
- Use "unittest.mock" library and drop "mock" installation
- Add SubnetInUseByIPsecSiteConnection in vpnaas exception
- Remove TooManyExternalNetworks exception class

* Tue Apr 07 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Mar 23 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Revert "Remove warning message when using old and new engine facade"
- Remove warning message when using old and new engine facade
- Fix definition of the fip_pf_description api extension
- Add is_sort_key for vpnaas attribute maps
- Introduce rbac-subnetpool api extension
- Introduce rbac-address-scope api extension
- Update the minversion parameter.

* Fri Mar 20 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Extend qos DriverBase with validate_rule_for_port()
- [Api-Ref][Docs] Change dns_assignment parameter to be list
- Remove library "six"
- Fix new parameter added in "qos_port_network_policy" API
- Stop testing Python 2
- Extension for tagging ports during bulk creation

* Thu Mar 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Extend qos DriverBase with validate_rule_for_port()
- [Api-Ref][Docs] Change dns_assignment parameter to be list
- Remove library "six"
- Fix new parameter added in "qos_port_network_policy" API
- Stop testing Python 2
- Extension for tagging ports during bulk creation
- Extend qos DriverBase with validate_rule_for_port()
- [Api-Ref][Docs] Change dns_assignment parameter to be list
- Remove library "six"
- Fix new parameter added in "qos_port_network_policy" API
- Stop testing Python 2
- Extension for tagging ports during bulk creation

* Thu Mar 12 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Extend qos DriverBase with validate_rule_for_port()
- [Api-Ref][Docs] Change dns_assignment parameter to be list
- Remove library "six"
- Fix new parameter added in "qos_port_network_policy" API
- Stop testing Python 2
- Extension for tagging ports during bulk creation

* Mon Jan 13 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Handle generation conflicts caused by concurrent updates
- Pass on missing implementation while filtering
- Merge "Add "qos_network_policy_id" field to "port" definition"
- Add "qos_network_policy_id" field to "port" definition

* Fri Dec 13 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Add description field in port forwarding API"
- Merge "Change the requirements for the subnet_dns_publish_fixed_ip extension"
- add "stateful-security-group" api extension
- Change the requirements for the subnet_dns_publish_fixed_ip extension
- Add description field in port forwarding API
- Merge "Remove 'interconnection' API extension definition (neutron-interconnection)"
- Remove 'interconnection' API extension definition (neutron-interconnection)
- Merge "Stop configuring install_command in tox."
- Stop configuring install_command in tox.
- Remove fwaas_v1 exceptions and definitions
- Merge "Allow <project_id>, <project_name>, <user_id> and <user_name> as DNS label"
- Allow <project_id>, <project_name>, <user_id> and <user_name> as DNS label
- Merge "Add retry and debug logs to NoAuthClient of placement client"
- Merge "install neutron_lib international messages"
- Fix rendering of api-ref main page
- install neutron_lib international messages
- Merge "Remove Neutron LBaaS"
- Add retry and debug logs to NoAuthClient of placement client
- Add missing DHCP port numbers
- Update master for stable/train
- Remove Neutron LBaaS
- Merge "PDF documentation build"
- PDF documentation build

* Wed Nov 13 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches


